/* <!-- START LICENSE -->


Program Ini Di buat Oleh DEVELOPER Dari PERUSAHAAN GLOBAL CORPORATION 
Social Media: 

- Youtube: https://youtube.com/@Global_Corporation 
- Github: https://github.com/globalcorporation
- TELEGRAM: https://t.me/GLOBAL_CORP_ORG_BOT

Seluruh kode disini di buat 100% murni tanpa jiplak / mencuri kode lain jika ada akan ada link komment di baris code

Jika anda mau mengedit pastikan kredit ini tidak di hapus / di ganti!

Jika Program ini milik anda dari hasil beli jasa developer di (Global Corporation / apapun itu dari turunan itu jika ada kesalahan / bug / ingin update segera lapor ke sub)

Misal anda beli Beli source code di Slebew CORPORATION anda lapor dahulu di slebew jangan lapor di GLOBAL CORPORATION!


<!-- END LICENSE --> */
// ignore_for_file: non_constant_identifier_names

import 'dart:convert';
import 'dart:typed_data';

import 'package:encrypt/encrypt.dart';

class Crypto {
  late String defaultKey;
  late String defaultIv;
  Crypto({
    required String key,
    String iv = "AAAAAAAAAAAAAAAAAAAAAA==",
  }) {
    defaultKey = key;
    defaultIv = iv;
  }

  String encrypt({
    required String data,
    String? newKey,
    String? iv,
  }) {
    iv ??= defaultIv;
    newKey ??= defaultKey;

    final encrypter = Encrypter(
      AES(
        Key.fromUtf8(newKey),
        mode: AESMode.ctr,
      ),
    );

    return encrypter.encrypt(data, iv: IV.fromBase64(iv)).base64;
  }

  String decrypt({
    required String data_base64,
    String? newKey,
    String? iv,
  }) {
    iv ??= defaultIv;
    newKey ??= defaultKey;

    final encrypter = Encrypter(
      AES(
        Key.fromUtf8(newKey),
        mode: AESMode.ctr,
      ),
    );

    return encrypter.decrypt64(data_base64, iv: IV.fromBase64(iv));
  }

  String encryptMapToBase64({
    required Map data,
  }) {
    return encryptToBase64(text: json.encode(data));
  }

  String encryptListToBase64({
    required List data,
  }) {
    return encryptToBase64(text: json.encode(data));
  }

  Uint8List encryptBytes({
    required List<int> data,
    String? key,
    String? iv,
  }) {
    iv ??= defaultIv;
    key ??= defaultKey;
    final encrypter = Encrypter(AES(Key.fromUtf8(key)));
    return encrypter.encryptBytes(data, iv: IV.fromBase64(iv)).bytes;
  }

  List<int> decryptBytes({
    required List<int> data,
    String? key,
    String? iv,
  }) {
    iv ??= defaultIv;
    key ??= defaultKey;
    final encrypter = Encrypter(AES(Key.fromUtf8(key)));
    return encrypter.decryptBytes(Encrypted(Uint8List.fromList(data)),
        iv: IV.fromBase64(iv));
  }

  Uint8List encryptsBytes({
    required List<int> data,
    required List<String> keys,
  }) {
    Uint8List uint8list = Uint8List.fromList(data);
    for (var i = 0; i < keys.length; i++) {
      String key = keys[i];
      uint8list = (encryptBytes(data: uint8list, key: key));
    }
    return uint8list;
  }

  List<int> decryptsBytes({
    required List<int> data,
    required List<String> keys,
  }) {
    List<int> uint8list = data;
    for (var i = keys.length - 1; i > -1; i--) {
      String key = keys[i];
      uint8list = (decryptBytes(data: uint8list, key: key));
    }
    return uint8list;
  }

  String encryptToBase64({
    required String text,
    String? key,
    String? iv,
  }) {
    iv ??= defaultIv;
    key ??= defaultKey;
    final encrypter = Encrypter(AES(Key.fromUtf8(key)));

    return encrypter.encrypt(text, iv: IV.fromBase64(iv)).base64;
  }

  String decryptFromBase64({
    required String text,
    String? key,
    String? iv,
  }) {
    iv ??= defaultIv;
    key ??= defaultKey;
    final encrypter = Encrypter(AES(Key.fromUtf8(key)));
    return encrypter.decrypt64(text, iv: IV.fromBase64(iv));
  }
}
