/* <!-- START LICENSE -->


Program Ini Di buat Oleh DEVELOPER Dari PERUSAHAAN GLOBAL CORPORATION 
Social Media: 

- Youtube: https://youtube.com/@Global_Corporation 
- Github: https://github.com/globalcorporation
- TELEGRAM: https://t.me/GLOBAL_CORP_ORG_BOT

Seluruh kode disini di buat 100% murni tanpa jiplak / mencuri kode lain jika ada akan ada link komment di baris code

Jika anda mau mengedit pastikan kredit ini tidak di hapus / di ganti!

Jika Program ini milik anda dari hasil beli jasa developer di (Global Corporation / apapun itu dari turunan itu jika ada kesalahan / bug / ingin update segera lapor ke sub)

Misal anda beli Beli source code di Slebew CORPORATION anda lapor dahulu di slebew jangan lapor di GLOBAL CORPORATION!


<!-- END LICENSE --> */
// ignore_for_file: unnecessary_brace_in_string_interps, non_constant_identifier_names, unnecessary_string_interpolations

import 'package:general_lib/extension/regexp.dart';
import 'package:general_lib/general_lib.dart';
import 'package:general_lib/scheme/duration_data_scheme.dart';

extension GeneralLibExtensionString on String {
  bool isFullData(RegExp regExp) {
    int count = 0;
    for (var i = 0; i < length; i++) {
      if (regExp.hashData(this[i])) {
        count += 1;
      }
    }
    return (count == length);
  }

  RegExp toRegExp({
    bool multiLine = false,
    bool caseSensitive = false,
    bool unicode = false,
    bool dotAll = false,
  }) {
    String message = "";
    for (var i = 0; i < length; i++) {
      String msg = this[i];
      String symbol = r"*#";
      String similar_word = "";

      if (RegExp(r"^(a)$", caseSensitive: false).hashData(msg)) {
        similar_word = "4";
      }
      if (RegExp(r"^(i)$", caseSensitive: false).hashData(msg)) {
        similar_word = "1";
      }
      if (RegExp(r"^(e)$", caseSensitive: false).hashData(msg)) {
        similar_word = "3";
      }
      if (RegExp(r"^(o)$", caseSensitive: false).hashData(msg)) {
        similar_word = "0";
      }
      if (RegExp(r"^(g)$", caseSensitive: false).hashData(msg)) {
        similar_word = "9";
      }
      if (RegExp(r"^(s)$", caseSensitive: false).hashData(msg)) {
        similar_word = "5";
      }

      if (!RegExp(r"^(a|i|u|e|o)$", caseSensitive: false).hashData(msg)) {
        if (length < 5) {
          symbol = "";
        }
      }

      String msg_data = "[${msg}${similar_word}${symbol}]";
      msg = "(${msg_data}+|${msg_data})";
      if (i == (length - 1)) {
        message += "${msg}";
      } else {
        message += "${msg}([ \\n]+)?";
      }
    }
    return RegExp(
      message,
      multiLine: multiLine,
      caseSensitive: caseSensitive,
      unicode: unicode,
      dotAll: dotAll,
    );
  }

  String hideData({int start = 2, int end = 2}) {
    var message = "";
    var numStart = start;
    var numEnd = length - end;
    for (int i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == numEnd) {
        numEnd--;
        message += loopData;
      } else if (i == numStart) {
        numStart++;
        message += "*";
      } else {
        message += loopData;
      }
    }
    return message;
  }

  String camelCaseClass({RegExp? regExp}) {
    regExp ??= RegExp(r"(_)", caseSensitive: false);
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == 0) {
        text += loopData.toUpperCase();
      } else {
        if (regExp.hasMatch(text[text.length - 1])) {
          text += loopData.toUpperCase();
        } else {
          text += loopData;
        }
      }
    }
    return text.replaceAll(regExp, "");
  }

  String toUpperCaseFirstData() {
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == 0) {
        text += loopData.toUpperCase();
      } else {
        text += loopData;
      }
    }
    return text;
  }

  String toLowerCaseFirstData() {
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == 0) {
        text += loopData.toLowerCase();
      } else {
        text += loopData;
      }
    }
    return text;
  }

  String snakeCaseClass({RegExp? regExp}) {
    regExp ??= RegExp(r"(_)", caseSensitive: false);
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (RegExp(r"[A-Z]").hashData(loopData) && i != 0) {
        text += "_${loopData}";
      } else {
        text += loopData;
      }
    }
    return text.toLowerCase();
  }

  /// text to duration
  /// example:
  ///
  /// days - hours - minutes - seconds - milliseconds - microseconds
  ///
  /// 0    -    0  -    0    -   0     -        0     -   0
  ///
  /// ```dart
  /// "0-0-0-0-0-0".toDuration();
  /// ```
  Duration toDuration(String value) {
    return Duration().fromText(value);
  }

  /// text to duration
  /// example:
  ///
  /// days - hours - minutes - seconds - milliseconds - microseconds
  ///
  /// 0    -    0  -    0    -   0     -        0     -   0
  ///
  /// ```dart
  /// "0-0-0-0-0-0".toDuration();
  /// ```
  String toDurationHumanReadAble() {
    DurationDataScheme durationData = DurationDataScheme({
      "@type": "durationDataScheme",
    });
    RegExpMatch? regExpMatch = RegExp(
            r"(([0-9]+)[ \-\~+]+([0-9]+)[ \-\~+]+([0-9]+)[ \-\~+]+([0-9]+)[ \-\~+]+([0-9]+)[ \-\~+]+([0-9]+))",
            caseSensitive: false)
        .firstMatch(this);
    if (regExpMatch != null) {
      List<String?> res = regExpMatch.groups([2, 3, 4, 5, 6, 7]);
      List<String> keys = [
        "days",
        "hours",
        "minutes",
        "seconds",
        "milliseconds",
        "microseconds",
      ];
      for (var i = 0; i < res.length; i++) {
        String? datas = res[i];
        if (datas == null) {
          continue;
        }
        try {
          durationData[keys[i]] = int.parse(datas);
        } catch (e) {}
      }
    }
    String message = "";
    if ((durationData.days ?? 0) > 0) {
      return "${durationData.days} Hari";
    }
    if ((durationData.hours ?? 0) > 0) {
      return "${durationData.hours} Jam";
    }
    if ((durationData.minutes ?? 0) > 0) {
      return "${durationData.minutes} Menit";
    }
    if (message.isEmpty) {
      message += "${durationData.seconds} Detik";
      if ((durationData.milliseconds ?? 0) > 1) {
        message += " ${durationData.milliseconds} Milli Detik";
      }

      if ((durationData.microseconds ?? 0) > 1) {
        message += " ${durationData.microseconds} Micro Detik";
      }
    }

    return message;
  }
}
