/* <!-- START LICENSE -->


Program Ini Di buat Oleh DEVELOPER Dari PERUSAHAAN GLOBAL CORPORATION 
Social Media: 

- Youtube: https://youtube.com/@Global_Corporation 
- Github: https://github.com/globalcorporation
- TELEGRAM: https://t.me/GLOBAL_CORP_ORG_BOT

Seluruh kode disini di buat 100% murni tanpa jiplak / mencuri kode lain jika ada akan ada link komment di baris code

Jika anda mau mengedit pastikan kredit ini tidak di hapus / di ganti!

Jika Program ini milik anda dari hasil beli jasa developer di (Global Corporation / apapun itu dari turunan itu jika ada kesalahan / bug / ingin update segera lapor ke sub)

Misal anda beli Beli source code di Slebew CORPORATION anda lapor dahulu di slebew jangan lapor di GLOBAL CORPORATION!


<!-- END LICENSE --> */
// ignore_for_file: empty_catches

import 'dart:convert';

import 'package:http/http.dart';

Future<Response> fetch(
  String url, {
  FetchOption? options,
  Encoding? encoding,
}) async {
  options ??= FetchOption(
    method: "get",
  );
  String method = (options.method).toLowerCase();

  Response response;
  if (method == "get") {
    response = await get(
      Uri.parse(url),
      headers: options.headers,
    );
  } else if (method == "post") {
    response = await post(Uri.parse(url),
        body: options.body, headers: options.headers, encoding: encoding);
  } else if (method == "put") {
    response = await put(Uri.parse(url),
        body: options.body, headers: options.headers, encoding: encoding);
  } else if (method == "patch") {
    response = await patch(Uri.parse(url),
        body: options.body, headers: options.headers, encoding: encoding);
  } else if (method == "delete") {
    response = await delete(Uri.parse(url),
        body: options.body, headers: options.headers, encoding: encoding);
  } else if (method == "head") {
    response = await head(Uri.parse(url), headers: options.headers);
  } else {
    response = await get(
      Uri.parse(url),
      headers: options.headers,
    );
  }

  return response;
}

extension OnFetch on Response {
  get text {
    return body;
  }

  Map? get jsonData {
    try {
      return json.decode(body);
    } catch (e) {
      return null;
    }
  }
}

class FetchOption {
  String method;
  Map<String, String>? headers;
  Object? body;
  FetchOption({
    required this.method,
    this.headers,
    this.body,
  });
}
