/* <!-- START LICENSE -->


Program Ini Di buat Oleh DEVELOPER Dari PERUSAHAAN GLOBAL CORPORATION 
Social Media: 

- Youtube: https://youtube.com/@Global_Corporation 
- Github: https://github.com/globalcorporation
- TELEGRAM: https://t.me/GLOBAL_CORP_ORG_BOT

Seluruh kode disini di buat 100% murni tanpa jiplak / mencuri kode lain jika ada akan ada link komment di baris code

Jika anda mau mengedit pastikan kredit ini tidak di hapus / di ganti!

Jika Program ini milik anda dari hasil beli jasa developer di (Global Corporation / apapun itu dari turunan itu jika ada kesalahan / bug / ingin update segera lapor ke sub)

Misal anda beli Beli source code di Slebew CORPORATION anda lapor dahulu di slebew jangan lapor di GLOBAL CORPORATION!


<!-- END LICENSE --> */
import "package:universal_io/io.dart";

DeviceId? getDeviceId({bool isGetProductId = false}) {
  if (Platform.isAndroid) {
    ProcessResult res =
        Process.runSync("settings", ["get", "secure", "android_id"]);
    return DeviceId(res);
  }

  if (Platform.isWindows) {
    ProcessResult res = Process.runSync("wmic", ["os", "get", "serialnumber"]);
    return DeviceId(res);
  }

  if (Platform.isLinux) {
    if (isGetProductId) {
      ProcessResult res = Process.runSync("dmidecode", ["-s", "system-uuid"]);
      return DeviceId(res);
    } else {
      ProcessResult res = Process.runSync("cat", ["/etc/machine-id"]);
      return DeviceId(res);
    }
  }
  return null;
}

class DeviceId {
  ProcessResult data;
  DeviceId(this.data);

  bool get isError {
    if (data.exitCode != 0) {
      return true;
    }
    return false;
  }

  String get errorMessage {
    return data.stderr.toString().replaceAll(RegExp(r"\n"), "");
  }

  String get deviceId {
    if (Platform.isWindows) {
      return RegExp(r"([a-z0-9]+)-([a-z0-9]+)-([a-z0-9]+)-([a-z0-9]+)",
                  caseSensitive: false)
              .stringMatch(
                  data.stdout.toString().replaceAll(RegExp(r"\n"), "")) ??
          "";
    }
    return data.stdout.toString().replaceAll(RegExp(r"\n"), "");
  }

  Map toJson() {
    if (!isError) {
      return {
        "@type": "device",
        "device_id": deviceId,
      };
    } else {
      return {"@type": "error", "message": errorMessage};
    }
  }
}
